/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    function onInitGateway(oGateway){
        //console.debug("./components/gateway/init.js");

        if(! (oGateway instanceof Gateway) ){
            throw "oGateway is not a Gateway instance";
            return false;
        }
        
        //Default name
        oGateway.setName(_D("New gateway"));

        //Default protocol
        oGateway.setProtocol("knx");

        //Enable/disable
        oGateway.addParamVal("enabled",true);
        
        //KNX
        oGateway.addParamVal("knx/address","0.0.0.0");
        oGateway.addParamVal("knx/port","3671");
        oGateway.addParamVal("knx/readinterval",250);

        //EVE
        oGateway.addParamVal("eve/address","");
        oGateway.addParamVal("eve/serial","");
        oGateway.addParamVal("eve/login","");
        oGateway.addParamVal("eve/password","");

        
        //BTICINO
        oGateway.addParamVal("bticino/address","0.0.0.0");
        oGateway.addParamVal("bticino/port",20000);
        oGateway.addParamVal("bticino/readinterval",250);
        
        //VIVALDI
        oGateway.addParamVal("vivaldi/address","0.0.0.0");
        oGateway.addParamVal("vivaldi/port",10001);
        oGateway.addParamVal("vivaldi/device-gid",1);

        //VIVALDI GIOVE FREE
        oGateway.addParamVal("vivaldigiovefree/address","0.0.0.0");
        oGateway.addParamVal("vivaldigiovefree/port",10001);
        oGateway.addParamVal("vivaldigiovefree/readinterval",500);			// Milliseconds to wait before ned read register
        oGateway.addParamVal("vivaldigiovefree/timeout",15000);				// Socket connection timeout in milliseconds
        oGateway.addParamVal("vivaldigiovefree/timeoutcrcerror",5000);		// Reset connection if crc error continue for this time (valid only for rtutcp)
        oGateway.addParamVal("vivaldigiovefree/waitfailed", 500);			// Milliseconds to wait if frame failed
        oGateway.addParamVal("vivaldigiovefree/retrytimes", 2);			    // how many times system have to retry if command fail ?
        oGateway.addParamVal("vivaldigiovefree/waitsuccess",0);				// Milliseconds to wait if frame success

        
        //ODIC
        oGateway.addParamVal("odic/address","0.0.0.0");
        oGateway.addParamVal("odic/port",10000);
        oGateway.addParamVal("odic/readinterval",500);
        
        //AVE
        oGateway.addParamVal("ave/address","0.0.0.0");
        oGateway.addParamVal("ave/port",7001);
        oGateway.addParamVal("ave/readinterval",500);
        
        //AERNOVA
        oGateway.addParamVal("aernova/address","0.0.0.0");
        oGateway.addParamVal("aernova/port",1001);
        oGateway.addParamVal("aernova/readinterval",50);
        
        //DATAGRAM
        oGateway.addParamVal("datagram/address","0.0.0.0");
        oGateway.addParamVal("datagram/port",21000);

        //HTTP
        oGateway.addParamVal("http/address","0.0.0.0");
        oGateway.addParamVal("http/port", 80);
        oGateway.addParamVal("http/request", 0); // 0 GET 1 POST 2 PUT
        oGateway.addParamVal("http/timeout", 1); // Response timeout in ms
        oGateway.addParamVal("http/authenticate",false);
        oGateway.addParamVal("http/user","");
        oGateway.addParamVal("http/password","");
       
        


        //Z-WAVE
        oGateway.addParamVal("zwave/port","com6");
		
		
		//MODBUS-TCP = modbustcp
		//To know the specific name of a protocol check file declarations/protocols.json
		//To add the graphic variables representation edit file components/gateway/gateway.html
		oGateway.addParamVal("modbustcp/address","0.0.0.0");		// The IP Address
        oGateway.addParamVal("modbustcp/port",502);						// Address port
		oGateway.addParamVal("modbustcp/readinterval",500);				// Milliseconds to wait before ned read register
		oGateway.addParamVal("modbustcp/timeout",15000);				// Socket connection timeout in milliseconds
		oGateway.addParamVal("modbustcp/timeoutcrcerror",5000);			// Reset connection if crc error continue for this time (valid only for rtutcp)							
		oGateway.addParamVal("modbustcp/waitfailed",500);				// Milliseconds to wait if frame failed
		oGateway.addParamVal("modbustcp/waitsuccess",0);				// Milliseconds to wait if frame success
		oGateway.addParamVal("modbustcp/bytesorder",1);					// How a words is composed 0 = LSB_MSB 1 = MSB_LSB
		
		//MODBUS-RTU-TCP = modbusrtutcp
		//To know the specific name of a protocol check file declarations/protocols.json
		oGateway.addParamVal("modbusrtutcp/address","0.0.0.0");	// The IP Address
        oGateway.addParamVal("modbusrtutcp/port",502);					// Address port
        oGateway.addParamVal("modbusrtutcp/asciitransform",false);		// Transform to Ascii
		oGateway.addParamVal("modbusrtutcp/readinterval",500);			// Milliseconds to wait before ned read register
		oGateway.addParamVal("modbusrtutcp/timeout",15000);				// Socket connection timeout in milliseconds
		oGateway.addParamVal("modbusrtutcp/timeoutcrcerror",5000);		// Reset connection if crc error continue for this time (valid only for rtutcp)							
		oGateway.addParamVal("modbusrtutcp/waitfailed",500);			// Milliseconds to wait if frame failed
		oGateway.addParamVal("modbusrtutcp/waitsuccess",0);				// Milliseconds to wait if frame success
		oGateway.addParamVal("modbusrtutcp/bytesorder",1);				// How a words is composed 0 = LSB_MSB 1 = MSB_LSB
    }
}
catch(err){
    console.error(err);
}
