/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        //eval( QT.readFile("./components/mainframe/init.js") );
        onInitMainframeComponent(oComponent);
        
        //Set default values
        oComponent.addParamVal("name", _D("Info")+" "+oComponent.UId);

        oComponent.addParamVal("values",[ { val: "", status: 0 } ]);
        
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();


        var panw=model["instance"].skin.IconsPan[0].imgWidth;
        var panh=model["instance"].skin.IconsPan[0].imgHeight;
        var iconw=model["instance"].skin.IconsPan[0].iconsWidth;
        var iconh=model["instance"].skin.IconsPan[0].iconsHeight;

		var i0=model["instance"].skin.IconsPan[0].ComponentsInfo.Info.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: true,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            color: {R:255,B:255,G:255},
            setSize: { h: panh, w: panw }
        });

        //Important: mantain original position
        aIcons.push(oIcon_status_0);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		//,{id:1, label:"Modal"}
        		,{id:2, label:"Only Text"}
        		//,{id:3, label:"Hidden"} 
        	]);



        oComponent.setParamVal("defaultViewMode",2);
        oComponent.setParamVal("defaultViewMode2",2);
        oComponent.setParamVal("defaultViewMode3",2);
        oComponent.setParamVal("defaultViewMode4",2);
        oComponent.setParamVal("defaultViewMode5",2);


        // KNX
        oComponent.addParamVal("knx/feedback-address","//");
        oComponent.addParamVal("knx/DPT","none");
        oComponent.addParamVal("knx/virtual-feedback",false);
        oComponent.addParamVal("knx/raw-value",false);
        oComponent.addParamVal("knx/raw-multiplier",1);
        oComponent.addParamVal("knx/raw-digits",1);
        oComponent.addParamVal("knx/raw-suffix","");
        oComponent.addParamVal("knx/read-init",true);
        
        // Vimar By Me protocol
        oComponent.addParamVal("vimar/device-pid","none");
        oComponent.addParamVal("vimar/device-fid","none");
        oComponent.addParamVal("vimar/group-address","");
        oComponent.addParamVal("vimar/physical-address","");

        oComponent.addParamVal("vimar/enable-sfbk",false);
        oComponent.addParamVal("vimar/sfbk","//");

        //Ghost
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");

        //GUI
        oComponent.addParamVal("gui/label","text");


        //EVE
        oComponent.addParamVal("eve/uid","");


        //Z-Wave
        oComponent.addParamVal("zwave/label","");
        oComponent.addParamVal("zwave/node",0);
        oComponent.addParamVal("zwave/instance",0);

        //Vivaldi
		oComponent.addParamVal("vivaldi/device-pid",2);
        oComponent.addParamVal("vivaldi/device-id",1);
        oComponent.addParamVal("vivaldi/device-fid", 0);

        // Vivaldi Giove Free
        oComponent.addParamVal("vivaldigiovefree/device-id", 1);
        oComponent.addParamVal("vivaldigiovefree/device-fid", 0);
        
        //Aernova
        oComponent.addParamVal("aernova/mode",1);
        oComponent.addParamVal("aernova/address","");
        
        //BTicino
       	oComponent.addParamVal("bticino/who", "none");
        oComponent.addParamVal("bticino/interface","none");
        oComponent.addParamVal("bticino/address","none");
        oComponent.addParamVal("bticino/sensor","none");
        oComponent.addParamVal("bticino/zone","none");
        oComponent.addParamVal("bticino/function","none");
        
        //Odic
       	oComponent.addParamVal("odic/variableid", 1);
        oComponent.addParamVal("odic/type", 0);
        oComponent.addParamVal("odic/rmin", "");
        oComponent.addParamVal("odic/rmax", "");
        oComponent.addParamVal("odic/smin", "");
        oComponent.addParamVal("odic/smax", "");
        oComponent.addParamVal("odic/tmin", "");
        oComponent.addParamVal("odic/tmax", "");

        //ModbusTCP
        oComponent.addParamVal("modbustcp/read-unit-id",0);
        oComponent.addParamVal("modbustcp/read-function-id",3);
        oComponent.addParamVal("modbustcp/read-register-start",0);
        oComponent.addParamVal("modbustcp/read-register-count",1);
        oComponent.addParamVal("modbustcp/read-bit-start",-1);
        oComponent.addParamVal("modbustcp/read-bit-count",0);
        oComponent.addParamVal("modbustcp/read-transform-type",1);
        oComponent.addParamVal("modbustcp/read-transform-min",0);
        oComponent.addParamVal("modbustcp/read-transform-max",1);
        oComponent.addParamVal("modbustcp/read-transform-multiplier", 1.0);
        oComponent.addParamVal("modbustcp/read-transform-digits", 3); 
        oComponent.addParamVal("modbustcp/read-transform-digits-format", 3);

        oComponent.addParamVal("modbustcp/write-unit-id",0);
        oComponent.addParamVal("modbustcp/write-function-id",6);
        oComponent.addParamVal("modbustcp/write-register-start",0);
        oComponent.addParamVal("modbustcp/write-register-count",1);
        oComponent.addParamVal("modbustcp/write-bit-start",-1);
        oComponent.addParamVal("modbustcp/write-bit-count",0);
        oComponent.addParamVal("modbustcp/write-transform-type",1);
        oComponent.addParamVal("modbustcp/write-transform-min",0);
        oComponent.addParamVal("modbustcp/write-transform-max",1);
        oComponent.addParamVal("modbustcp/write-transform-multiplier",1.0);
         
        //ModbusRTUTCP
        oComponent.addParamVal("modbusrtutcp/read-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/read-function-id",3);
        oComponent.addParamVal("modbusrtutcp/read-register-start",0);
        oComponent.addParamVal("modbusrtutcp/read-register-count",1);
        oComponent.addParamVal("modbusrtutcp/read-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/read-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/read-transform-type",1);
        oComponent.addParamVal("modbusrtutcp/read-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/read-transform-max",1);
        oComponent.addParamVal("modbusrtutcp/read-transform-multiplier", 1.0);
        oComponent.addParamVal("modbusrtutcp/read-transform-digits", 3);
        oComponent.addParamVal("modbusrtutcp/read-transform-digits-format",3);

        oComponent.addParamVal("modbusrtutcp/write-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/write-function-id",6);
        oComponent.addParamVal("modbusrtutcp/write-register-start",0);
        oComponent.addParamVal("modbusrtutcp/write-register-count",1);
        oComponent.addParamVal("modbusrtutcp/write-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/write-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/write-transform-type",1);
        oComponent.addParamVal("modbusrtutcp/write-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/write-transform-max",1);
        oComponent.addParamVal("modbusrtutcp/write-transform-multiplier",1.0);
    };
}
catch(err){
    console.error(err);
}
