/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        onInitMainframeComponent(oComponent);
        
        //Set default values
        oComponent.addParamVal("name", _D("Shutter")+" "+oComponent.UId);
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oIcon_status_1 = new Icon();
        var oIcon_status_2 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
		
		
                var panw=model["instance"].skin.IconsPan[0].imgWidth;
        var panh=model["instance"].skin.IconsPan[0].imgHeight;
        var iconw=model["instance"].skin.IconsPan[0].iconsWidth;
        var iconh=model["instance"].skin.IconsPan[0].iconsHeight;

		var i0=model["instance"].skin.IconsPan[0].ComponentsInfo.Shutter.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        var i1=model["instance"].skin.IconsPan[0].ComponentsInfo.Shutter.defaultIcons[1];
        $.extend(true, oIcon_status_1, {
            status: 1,
            position:{ x: -i1.position.x*iconw, y: -i1.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }
        });
        var i1=model["instance"].skin.IconsPan[0].ComponentsInfo.Shutter.defaultIcons[2];
        $.extend(true, oIcon_status_2, {
            status: 2,
            position:{ x: -i1.position.x*iconw, y: -i1.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }
        });
        
        //Important: mantain original position
        aIcons.push(oIcon_status_0);
        aIcons.push(oIcon_status_1);
        aIcons.push(oIcon_status_2);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		,{id:1, label:"Modal"}
        		//,{id:2, label:"Only Text"}
        		,{id:3, label:"Hidden"} 
        	]);
        oComponent.addParamVal("working-time",20000);

        // KNX
        oComponent.addParamVal("knx/long-operation/write-address","//");
        oComponent.addParamVal("knx/long-operation/feedback-address","//");
        oComponent.addParamVal("knx/short-operation/write-address","//");
        oComponent.addParamVal("knx/short-operation/feedback-address","//");
        oComponent.addParamVal("knx/virtual-feedback",false);
        oComponent.addParamVal("knx/read-init",true);
        
        //Vimar
        oComponent.addParamVal("vimar/device-pid","none");
        oComponent.addParamVal("vimar/device-fid","none");
        oComponent.addParamVal("vimar/group-address","");
        oComponent.addParamVal("vimar/physical-address","");
        oComponent.addParamVal("vimar/enable-sfbk",false);
        oComponent.addParamVal("vimar/sfbk","//");

        //Ghost
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");

        //BTicino
       	oComponent.addParamVal("bticino/who",2);
        oComponent.addParamVal("bticino/interface", "");
        oComponent.addParamVal("bticino/address","01");
        oComponent.addParamVal("bticino/function",0);


        //ModbusTCP
        oComponent.addParamVal("modbustcp/open-read-unit-id",0);
        oComponent.addParamVal("modbustcp/open-read-function-id",3);
        oComponent.addParamVal("modbustcp/open-read-register-start",0);
        oComponent.addParamVal("modbustcp/open-read-register-count",1);
        oComponent.addParamVal("modbustcp/open-read-bit-start",-1);
        oComponent.addParamVal("modbustcp/open-read-bit-count",0);
        oComponent.addParamVal("modbustcp/open-read-transform-type",1);
        oComponent.addParamVal("modbustcp/open-read-transform-min",0);
        oComponent.addParamVal("modbustcp/open-read-transform-max",1);
        oComponent.addParamVal("modbustcp/open-read-transform-multiplier",1.0);
        oComponent.addParamVal("modbustcp/open-write-unit-id",0);
        oComponent.addParamVal("modbustcp/open-write-function-id",6);
        oComponent.addParamVal("modbustcp/open-write-register-start",0);
        oComponent.addParamVal("modbustcp/open-write-register-count",1);
        oComponent.addParamVal("modbustcp/open-write-bit-start",-1);
        oComponent.addParamVal("modbustcp/open-write-bit-count",0);
        oComponent.addParamVal("modbustcp/open-write-transform-type",1);
        oComponent.addParamVal("modbustcp/open-write-transform-min",0);
        oComponent.addParamVal("modbustcp/open-write-transform-max",1);
        oComponent.addParamVal("modbustcp/open-write-transform-multiplier",1.0);
        oComponent.addParamVal("modbustcp/stop-read-unit-id",0);
        oComponent.addParamVal("modbustcp/stop-read-function-id",3);
        oComponent.addParamVal("modbustcp/stop-read-register-start",0);
        oComponent.addParamVal("modbustcp/stop-read-register-count",1);
        oComponent.addParamVal("modbustcp/stop-read-bit-start",-1);
        oComponent.addParamVal("modbustcp/stop-read-bit-count",0);
        oComponent.addParamVal("modbustcp/stop-read-transform-type",1);
        oComponent.addParamVal("modbustcp/stop-read-transform-min",0);
        oComponent.addParamVal("modbustcp/stop-read-transform-max",1);
        oComponent.addParamVal("modbustcp/stop-read-transform-multiplier",1.0);
        oComponent.addParamVal("modbustcp/stop-write-unit-id",0);
        oComponent.addParamVal("modbustcp/stop-write-function-id",6);
        oComponent.addParamVal("modbustcp/stop-write-register-start",0);
        oComponent.addParamVal("modbustcp/stop-write-register-count",1);
        oComponent.addParamVal("modbustcp/stop-write-bit-start",-1);
        oComponent.addParamVal("modbustcp/stop-write-bit-count",0);
        oComponent.addParamVal("modbustcp/stop-write-transform-type",1);
        oComponent.addParamVal("modbustcp/stop-write-transform-min",0);
        oComponent.addParamVal("modbustcp/stop-write-transform-max",1);
        oComponent.addParamVal("modbustcp/stop-write-transform-multiplier",1.0);
        oComponent.addParamVal("modbustcp/close-read-unit-id",0);
        oComponent.addParamVal("modbustcp/close-read-function-id",3);
        oComponent.addParamVal("modbustcp/close-read-register-start",0);
        oComponent.addParamVal("modbustcp/close-read-register-count",1);
        oComponent.addParamVal("modbustcp/close-read-bit-start",-1);
        oComponent.addParamVal("modbustcp/close-read-bit-count",0);
        oComponent.addParamVal("modbustcp/close-read-transform-type",1);
        oComponent.addParamVal("modbustcp/close-read-transform-min",0);
        oComponent.addParamVal("modbustcp/close-read-transform-max",1);
        oComponent.addParamVal("modbustcp/close-read-transform-multiplier",1.0);
        oComponent.addParamVal("modbustcp/close-write-unit-id",0);
        oComponent.addParamVal("modbustcp/close-write-function-id",6);
        oComponent.addParamVal("modbustcp/close-write-register-start",0);
        oComponent.addParamVal("modbustcp/close-write-register-count",1);
        oComponent.addParamVal("modbustcp/close-write-bit-start",-1);
        oComponent.addParamVal("modbustcp/close-write-bit-count",0);
        oComponent.addParamVal("modbustcp/close-write-transform-type",1);
        oComponent.addParamVal("modbustcp/close-write-transform-min",0);
        oComponent.addParamVal("modbustcp/close-write-transform-max",1);
        oComponent.addParamVal("modbustcp/close-write-transform-multiplier",1.0);

        //ModbusRTUTCP
        oComponent.addParamVal("modbusrtutcp/open-read-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/open-read-function-id",3);
        oComponent.addParamVal("modbusrtutcp/open-read-register-start",0);
        oComponent.addParamVal("modbusrtutcp/open-read-register-count",1);
        oComponent.addParamVal("modbusrtutcp/open-read-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/open-read-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/open-read-transform-type",1);
        oComponent.addParamVal("modbusrtutcp/open-read-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/open-read-transform-max",1);
        oComponent.addParamVal("modbusrtutcp/open-read-transform-multiplier",1.0);
        oComponent.addParamVal("modbusrtutcp/open-write-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/open-write-function-id",6);
        oComponent.addParamVal("modbusrtutcp/open-write-register-start",0);
        oComponent.addParamVal("modbusrtutcp/open-write-register-count",1);
        oComponent.addParamVal("modbusrtutcp/open-write-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/open-write-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/open-write-transform-type",1);
        oComponent.addParamVal("modbusrtutcp/open-write-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/open-write-transform-max",1);
        oComponent.addParamVal("modbusrtutcp/open-write-transform-multiplier",1.0);
        oComponent.addParamVal("modbusrtutcp/stop-read-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/stop-read-function-id",3);
        oComponent.addParamVal("modbusrtutcp/stop-read-register-start",0);
        oComponent.addParamVal("modbusrtutcp/stop-read-register-count",1);
        oComponent.addParamVal("modbusrtutcp/stop-read-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/stop-read-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/stop-read-transform-type",1);
        oComponent.addParamVal("modbusrtutcp/stop-read-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/stop-read-transform-max",1);
        oComponent.addParamVal("modbusrtutcp/stop-read-transform-multiplier",1.0);
        oComponent.addParamVal("modbusrtutcp/stop-write-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/stop-write-function-id",6);
        oComponent.addParamVal("modbusrtutcp/stop-write-register-start",0);
        oComponent.addParamVal("modbusrtutcp/stop-write-register-count",1);
        oComponent.addParamVal("modbusrtutcp/stop-write-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/stop-write-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/stop-write-transform-type",1);
        oComponent.addParamVal("modbusrtutcp/stop-write-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/stop-write-transform-max",1);
        oComponent.addParamVal("modbusrtutcp/stop-write-transform-multiplier",1.0);
        oComponent.addParamVal("modbusrtutcp/close-read-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/close-read-function-id",3);
        oComponent.addParamVal("modbusrtutcp/close-read-register-start",0);
        oComponent.addParamVal("modbusrtutcp/close-read-register-count",1);
        oComponent.addParamVal("modbusrtutcp/close-read-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/close-read-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/close-read-transform-type",1);
        oComponent.addParamVal("modbusrtutcp/close-read-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/close-read-transform-max",1);
        oComponent.addParamVal("modbusrtutcp/close-read-transform-multiplier",1.0);
        oComponent.addParamVal("modbusrtutcp/close-write-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/close-write-function-id",6);
        oComponent.addParamVal("modbusrtutcp/close-write-register-start",0);
        oComponent.addParamVal("modbusrtutcp/close-write-register-count",1);
        oComponent.addParamVal("modbusrtutcp/close-write-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/close-write-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/close-write-transform-type",1);
        oComponent.addParamVal("modbusrtutcp/close-write-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/close-write-transform-max",1);
        oComponent.addParamVal("modbusrtutcp/close-write-transform-multiplier",1.0);

    };
}
catch(err){
    console.error(err);
}
