/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Init Component Function (Required)
     * Initialize component when component is dragged to component list
     */
    function onInitComponent(oComponent){
        //console.log("%c/components/"+ oComponent.getType() +"/initialization","color:purple");
        
        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        onInitMainframeComponent(oComponent);


        
        //Set default values
        oComponent.addParamVal("name", _D("Thermostat")+" "+oComponent.UId);
        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();
        var oIcon_status_1 = new Icon();
        var oIcon_status_2 = new Icon();
        var oIcon_status_3 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
        
        var panw=model["instance"].skin.IconsPan[0].imgWidth;
        var panh=model["instance"].skin.IconsPan[0].imgHeight;
        var iconw=model["instance"].skin.IconsPan[0].iconsWidth;
        var iconh=model["instance"].skin.IconsPan[0].iconsHeight;

		var i0=model["instance"].skin.IconsPan[0].ComponentsInfo.Thermostat.defaultIcons[0];
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: -i0.position.x*iconw, y: -i0.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        var i1=model["instance"].skin.IconsPan[0].ComponentsInfo.Thermostat.defaultIcons[1];
        $.extend(true, oIcon_status_1, {
            status: 1,
            position:{ x: -i1.position.x*iconw, y: -i1.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        var i2=model["instance"].skin.IconsPan[0].ComponentsInfo.Thermostat.defaultIcons[2];
        $.extend(true, oIcon_status_2, {
            status: 2,
            position:{ x: -i2.position.x*iconw, y: -i2.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });
        var i3=model["instance"].skin.IconsPan[0].ComponentsInfo.Thermostat.defaultIcons[3];
        $.extend(true, oIcon_status_3, {
            status: 3,
            position:{ x: -i3.position.x*iconw, y: -i3.position.y*iconh },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: iconh, w: iconw },
            setSize: { h: panh, w: panw }

        });

        //Important: mantain original position
        aIcons.push(oIcon_status_0);
        aIcons.push(oIcon_status_1);
        aIcons.push(oIcon_status_2);
        aIcons.push(oIcon_status_3);
        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		,{id:1, label:"Modal"}
        		//,{id:2, label:"Only Text"}
        		,{id:3, label:"Hidden"} 
        	]);

        
        // Knx
        oComponent.addParamVal("knx/write-address","//");
        oComponent.addParamVal("knx/feedback-address","//");
        oComponent.addParamVal("knx/virtual-feedback",false);
        oComponent.addParamVal("knx/read-init",true);
        
        // Vimar
        oComponent.addParamVal("vimar/device-pid","none");
        oComponent.addParamVal("vimar/device-fid","none");
        oComponent.addParamVal("vimar/group-address","");
        oComponent.addParamVal("vimar/physical-address","");
        oComponent.addParamVal("vimar/enable-sfbk",false);
        oComponent.addParamVal("vimar/sfbk","//");

        //Ghost
        oComponent.addParamVal("ghost/virtual-feedback",true);
        oComponent.addParamVal("ghost/userdata","");
		
		//Z-Wave
        oComponent.addParamVal("zwave/label","");
        oComponent.addParamVal("zwave/node",0);
        oComponent.addParamVal("zwave/instance",0);
        
        //Aernova
        oComponent.addParamVal("aernova/mode",1);
        oComponent.addParamVal("aernova/address","");

        //BTicino
       	oComponent.addParamVal("bticino/who",4);
        oComponent.addParamVal("bticino/interface", "");
        oComponent.addParamVal("bticino/type", 0);
        oComponent.addParamVal("bticino/address","#1");
        oComponent.addParamVal("bticino/function",14);
        
        //Odic
       	oComponent.addParamVal("odic/variableid", 1);
        oComponent.addParamVal("odic/type", 0);
        oComponent.addParamVal("odic/rmin", "");
        oComponent.addParamVal("odic/rmax", "");
        oComponent.addParamVal("odic/smin", "");
        oComponent.addParamVal("odic/smax", "");
        oComponent.addParamVal("odic/tmin", "");
        oComponent.addParamVal("odic/tmax", "");

        //ModbusTCP
        oComponent.addParamVal("modbustcp/read-unit-id",0);
        oComponent.addParamVal("modbustcp/read-function-id",3);
        oComponent.addParamVal("modbustcp/read-register-start",0);
        oComponent.addParamVal("modbustcp/read-register-count",1);
        oComponent.addParamVal("modbustcp/read-bit-start",-1);
        oComponent.addParamVal("modbustcp/read-bit-count",0);
        oComponent.addParamVal("modbustcp/read-transform-type",4);
        oComponent.addParamVal("modbustcp/read-transform-min",0);
        oComponent.addParamVal("modbustcp/read-transform-max",65535);
        oComponent.addParamVal("modbustcp/read-transform-multiplier",0.1);
        oComponent.addParamVal("modbustcp/write-unit-id",0);
        oComponent.addParamVal("modbustcp/write-function-id",6);
        oComponent.addParamVal("modbustcp/write-register-start",0);
        oComponent.addParamVal("modbustcp/write-register-count",1);
        oComponent.addParamVal("modbustcp/write-bit-start",-1);
        oComponent.addParamVal("modbustcp/write-bit-count",0);
        oComponent.addParamVal("modbustcp/write-transform-type",4);
        oComponent.addParamVal("modbustcp/write-transform-min",0);
        oComponent.addParamVal("modbustcp/write-transform-max",65535);
        oComponent.addParamVal("modbustcp/write-transform-multiplier",0.1);

        //ModbusRTUTCP
        oComponent.addParamVal("modbusrtutcp/read-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/read-function-id",3);
        oComponent.addParamVal("modbusrtutcp/read-register-start",0);
        oComponent.addParamVal("modbusrtutcp/read-register-count",1);
        oComponent.addParamVal("modbusrtutcp/read-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/read-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/read-transform-type",4);
        oComponent.addParamVal("modbusrtutcp/read-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/read-transform-max",65535);
        oComponent.addParamVal("modbusrtutcp/read-transform-multiplier",0.1);
        oComponent.addParamVal("modbusrtutcp/write-unit-id",0);
        oComponent.addParamVal("modbusrtutcp/write-function-id",6);
        oComponent.addParamVal("modbusrtutcp/write-register-start",0);
        oComponent.addParamVal("modbusrtutcp/write-register-count",1);
        oComponent.addParamVal("modbusrtutcp/write-bit-start",-1);
        oComponent.addParamVal("modbusrtutcp/write-bit-count",0);
        oComponent.addParamVal("modbusrtutcp/write-transform-type",4);
        oComponent.addParamVal("modbusrtutcp/write-transform-min",0);
        oComponent.addParamVal("modbusrtutcp/write-transform-max",65535);
        oComponent.addParamVal("modbusrtutcp/write-transform-multiplier",0.1);
        
    };
}
catch(err){
    console.error(err);
}
