/** Database Manager class (extends Window class)
 *
 * @class databaseManager
 *
 *
 * @author <a href="mailto:info@ilevia.com">info@ilevia.com</a>
 */
"use strict";

function databaseManager(oWindow){
	
	var self = this;
	
	/**
	 *
	 */
	var init = function(){
        console.log("%cWindow - databaseManager class initialization (extends Window class)","color:green");
        
        //Create jQuery UI dialog
        m_$element.dialog({
            //height: 300,
            height: "auto",
            //width: 600,
            width: "auto",
            minWidth: 360,
            autoOpen: false,
            modal: true,
            resizable: false,
            close: m_oWindow.hide,
            create: function(e,ui){
                $(this).find("button").button();
            }
        });


        //On search
        m_$element.on("click",".search-eve",function(e){
            m_$element.find(".eve-list").empty();

            QT.discover(function(strServer){
                var aParams = strServer.split("|");

                var ip = "<span class='ip' style='font-size: larger; display: inline-block; width: 150px;'>"+ aParams[0] +"</span>";
                var type = "<span style='display: inline-block; width: 140px;'>"+ aParams[2] +"</span>";
                var sn = "<span class='serial' style='display: inline-block; width: 100px;'>"+ ( (aParams[3] != undefined)?aParams[3]:"") +"</span>";

                $("#databaseManager").find(".eve-list").append("<li style='cursor: pointer'>"+ ip + type + sn +"</li>");
            });

            // http://www.ilevia.com/info/eve.php?data={%22serial%22:%22z5530u28%22}
            // request last ip from ilevia server connection

            //   url: "http://www.ilevia.com/info/eve.php?data={serial:"+m_$element.find(".serial")+"}",
            var serial=m_$element.find(".serial").val();
            console.log(m_$element);
            console.log("http://www.ilevia.com/info/eveok.php?data={serial:'"+serial+"'}");
            $.ajax({
                url: "http://www.ilevia.com/info/eveok.php?data={serial:'"+serial+"'}",
                cache: false,
                dataType: "jsonp",
                success: function(json){

                    console.log(json);
                    if (json.localip!="")
                    {
                        var lip = "<span class='ip' style='font-size: larger; display: inline-block; width: 150px;'>"+ json.localip +"</span>";

                        $("#databaseManager").find(".eve-list").append("<li style='cursor: pointer'>"+ lip +"</li>");

                    }
                    if (json.remoteip!="") {
                        var rip = "<span class='ip' style='font-size: larger; display: inline-block; width: 150px;'>" + json.remoteip + "</span>";

                        $("#databaseManager").find(".eve-list").append("<li style='cursor: pointer'>" + rip + "</li>");
                    }
                },
                error: function(jqXHR,textStatus,errorThrown){

                    console.error(textStatus);
                }
            });


        });

        //On choose ip
        m_$element.on("click",".eve-list li",function(e){

            m_$element.find(".ipAddress").val($(this).find(".ip").text());
            m_$element.find(".serial").val($(this).find(".serial").text());

        });
        
        //On submit search form
        m_$element.on("submit","form",self._submit);
        
        //On reset
        m_$element.on("click",".cancel",function(e){
            m_oWindow.hide();
        });
        
    };
	
	/** Extended window object 
     * @type {Window}
     */
	var m_oWindow = oWindow;
	
	/** jQuery DOM element representing Window GUI
     * @type {jQuery}
     */
    var m_$element;

    /** Additional parameters
     * @type {undefined}
     */
    var m_oParam = undefined;
	
	/** Last saved connection parameters
	 * 
	 */
	this.connectionParam = {
	    address: "10.0.0.100",
	    port: "18000",
	    user: "admin",
        serial: ""
	};
	
	/** Show upload/download window
	 * @param {object} oParam Generic parameters
	 */
	this.show = function(oParam){

	    if(m_$element == undefined || m_$element.length < 1){
	        console.error("Window object databaseManager not be initialized");
	        return;
	    }

        //Set parameters
        m_oParam = oParam;
	    
	    //Change title
	    m_$element.dialog("option","title", _D( m_oParam["command"].capitalizeFirst() ) );
        m_$element.find(".command").val(m_oParam["command"]);

        if(m_oParam["command"] == "upload" || m_oParam["command"] == "download" || m_oParam["command"] == "connect"){
            //Fill address
            if(model["lastIP"] != undefined){
                m_$element.find("input.ipAddress").val(model["lastIP"]);
            }
            else{
                m_$element.find("input.ipAddress").val(self.connectionParam.address);
            }

            m_$element.find("input.serial").val(model["lastSerial"]);

            //Fill port
            //Fill address
            if(model["lastIP"] != undefined){
                m_$element.find("input.port").val(model["lastPort"]);
            }
            else{
                m_$element.find("input.port").val(self.connectionParam.port);
            }

            //m_$element.find("input.port").val(self.connectionParam.port);
            if(m_$element.find("input.port").val().length < 1){
                m_$element.find("input.port").val(18000);
            }

            //Fill user
            m_$element.find("input.user").val(self.connectionParam.user);

            if (self.connectionParam.password==undefined)
            {

                self.connectionParam.password="password";

            }
            //Fill password
            m_$element.find(".password").val(self.connectionParam.password);

            //Hide error field
            m_$element.find(".error").hide();
        }
        else if(m_oParam["command"] == "load"){
            //m_$element.find(".user").val("");           //Empty user
            //m_$element.find(".user").val("admin");           //Empty user
            m_$element.find(".password").val("");       //Empty password
            //m_$element.find(".password").val("password");       //Empty password

            m_$element.find("ul li:eq(0)").hide();      //Hide ip address
            m_$element.find("ul li:eq(1)").hide();      //Hide ip address
            m_$element.find("ul li:eq(4)").hide();      //Hide save password

            m_$element.find(".search-eve").hide();      //Hide search
            m_$element.find("hr.search-eve").hide();      //Hide
            m_$element.find(".eve-list").hide();      //Hide


            m_$element.find(".user").focus();
        }
	    
	    //Open dialog
	    m_$element.dialog("open");
	};
	
	/** Hide window and closing operation
	 * @param {event} e Event
	 * @param {object} ui
	 */
	this.hide = function(e,ui){
        m_$element.find("ul li").show();      //Show list items
        m_$element.find(".error-msg").empty().hide();

        m_$element.find(".search-eve").show();      //Hide search
        m_$element.find("hr.search-eve").show();      //Hide
        m_$element.find(".eve-list").show();      //Hide

        //Close
        m_$element.dialog("close");
	};
	
	/** Assign window HTML element 
     * @param {jQuery} $element jQuery element represent this window
     */
    this.assignWindow = function($element){
        m_$element = $element;
        
        //Initialization after graphic ready
        init();
    };
    
    /** Interactions methods */
   
    /** Submit
     * 
     */
    this._submit = function(e){
        //Save sessions parameters
        self.connectionParam.address = m_$element.find(".ipAddress").val();
        self.connectionParam.port = m_$element.find(".port").val();
        self.connectionParam.user = m_$element.find(".user").val();
        self.connectionParam.serial = m_$element.find(".serial").val();

        model["lastIP"] = self.connectionParam.address;
        model["lastPort"] = self.connectionParam.port;
        model["lastSerial"] = self.connectionParam.serial;

        //Check password saving
        if( $(".save-password").prop("checked") ){
            //self.connectionParam.password = hex_md5( m_$element.find(".password").val() );
            self.connectionParam.password = m_$element.find(".password").val();
        }
        else{

            delete self.connectionParam.password;
        }
        
        //m_$element.dialog("close");

        application.saveUser();

        //Check command
        switch( m_oParam["command"] ){

            case "connect":
                //console.warn("Set upload preferences");
                $document.trigger("app/load/begin",["Connecting"]);

                /*
                 console.log(m_$element.find(".ipAddress").val());
                 console.log(m_$element.find(".port").val());
                 console.log(m_$element.find(".user").val());
                 console.log(hex_md5( m_$element.find(".password").val() ));
                 console.log("%cConnecting...","background-color:blue; color: white;");
                 */

                QT.eve.connect(
                    m_$element.find(".ipAddress").val(),
                    m_$element.find(".port").val(),
                    m_$element.find(".user").val(),
                    //hex_md5( m_$element.find(".password").val() ),
                    m_$element.find(".password").val(),
                    function(json){
                        //console.log("RESPONSE: "+ json);

                        switch(json){
                            case "Connection State Try to connecting":
                                return;
                                break;
                            case "Connection State Authentication Failed":
                                $document.trigger("app/load/end");
                                $("#databaseManager").find(".error-msg").text(json).show();
                                return;
                                break;
                            case "Connection Ready":
                                QT.eve.getComponentsValue();
                                break;
                            case "Connection State Control: Authentication success":
                            case "Connection State Authentication success":
                                console.log(json);
                                return;
                            default:
                                $document.trigger("app/load/end");
                                $("#databaseManager").find(".error-msg").text(json).show();
                                console.warn(json);
                                return;
                        }

                        $document.trigger("app/load/end");
                        $("#databaseManager").dialog("close");

                        //$.publish("/view/application/refresh/connection",true);
                    }
                );
                break;
            case "upload":
                //console.warn("Set upload preferences");
                //setTimeout(function(){
                    $document.trigger("app/load/begin",["Connecting"]);
                //},1);


                /*
                console.log(m_$element.find(".ipAddress").val());
                console.log(m_$element.find(".port").val());
                console.log(m_$element.find(".user").val());
                console.log(hex_md5( m_$element.find(".password").val() ));
                console.log("%cConnecting...","background-color:blue; color: white;");
                */

                model["bWasConnect"] = QT.eve.isConnect();

                QT.eve.connect(
                    m_$element.find(".ipAddress").val(),
                    m_$element.find(".port").val(),
                    m_$element.find(".user").val(),
                    //hex_md5( m_$element.find(".password").val() ),
                    m_$element.find(".password").val(),
                    function(json){
                        console.log("RESPONSE: "+ json);

                        switch(json){
                            case "Connection State Try to connecting":
                                return;
                                break;
                            case "Connection State Authentication Failed":
                                $document.trigger("app/load/end");
                                $("#databaseManager").find(".error-msg").text(json).show();
                                return;
                                break;
                            case "Connection State Socket operation timed out":
                                $document.trigger("app/load/end");
                                $("#databaseManager").find(".error-msg").text(json).show();
                                return;
                                break;
                            case "Connection Ready":
                                break;
                            case "Connection State Authentication success":
                                console.log(json);
                                return;
                            default:
                                console.warn(json);
                                return;
                        }
                        /*if(json != "Connection Ready"){
                            return;
                        }*/
                        
                        //Save temporary project
                        //console.warn(QT.applicationPath());
                        //console.warn(QT.applicationPath() +"/data/temp_upload.eve");
                        
                        var oResp = application.saveProject(QT.applicationPath() +"/data/temp_upload.eve");
                        
                        $document.trigger("app/load/end");
                        $("#databaseManager").dialog("close");

                        if(oResp == undefined){
                            return;
                        }

                        $document.trigger("app/load/begin",["Check server project..."]);

                      //  console.error(m_oParam.project.projectPath);
                        console.log("MD5="+model["project/md5"]);
                        QT.eve.EVEDatabaseMD5(function(md5){
                            //console.error(md5);

                            $document.trigger("app/load/end");

                            var tempUpload = function(){
                                $document.trigger("app/load/begin",["Upload project","bar"]);

                                //Start upload
                                QT.eve.upload(
                                    QT.applicationPath() +"/data/temp_upload.eve",
                                    function(json){
                                        console.warn(json);

                                        //Progress bar
                                        console.error( json["GetPercentage"] );
                                        $("#loader").find(".progressbar").progressbar("value", parseInt(json["GetPercentage"],10));

                                        //Check if is end
                                        if(! (json["IsEnd"] === "true") ){
                                            return;
                                        }

                                        $("#loader").find(".progressbar").progressbar("value", 100);

                                        //Disconnect Eve
                                        if(!model["bWasConnect"]){
                                            QT.eve.disconnect();
                                        }

                                        delete model["bWasConnect"]

                                        //Remove temporary project
                                        QT.deleteFile("../temp_upload.eve");

                                        $document.trigger("app/load/end");

                                        if(json["GetError"] > 0){
                                            $document.trigger("app/error",["Upload error"]);
                                            $document.trigger("app/error",json["GetInfo"]);
                                        }

                                        //$document.trigger("app/info",["Upload complete"]);

                                    }//end callback function
                                );
                            };

                            if(md5 != model["project/md5"]){
                              //  $document.trigger("app/confirm",["Project is different. Continue?",function(){
                                    tempUpload();
                              //  }]);
                            }
                            else{
                                tempUpload();
                            }
                        });

                        /*$document.trigger("app/load/begin",["Upload project","bar"]);
                        
                        //Start upload
                        QT.eve.upload(
                            QT.applicationPath() +"/data/temp_upload.eve",
                            function(json){
                                //console.warn(json);

                                //Progress bar
                                //console.error( json["GetPercentage"] );
                                $("#loader").find(".progressbar").progressbar("value", parseInt(json["GetPercentage"],10));

                                //Check if is end
                                if(! (json["IsEnd"] === "true") ){
                                    return;
                                }

                                $("#loader").find(".progressbar").progressbar("value", 100);

                                //Disconnect Eve
                                QT.eve.disconnect();

                                //Remove temporary project
                                QT.deleteFile("../temp_upload.eve");

                                $document.trigger("app/load/end");

                                if(json["GetError"] > 0){
                                    //$document.trigger("app/error",["Upload error"]);
                                    $document.trigger("app/error",json["GetInfo"]);
                                }

                            }//end callback function
                        );*/
                    }
                );
                break;
            case "download":
                //console.warn("Set download preferences");
                $document.trigger("app/load/begin",["Connecting"]);

                model["bWasConnect"] = QT.eve.isConnect();
                
                QT.eve.connect(
                    m_$element.find(".ipAddress").val(),
                    m_$element.find(".port").val(),
                    m_$element.find(".user").val(),
                    //hex_md5( m_$element.find(".password").val() ),
                    m_$element.find(".password").val(),
                    function(json){

                        switch(json){
                            case "Connection State Try to connecting":
                                return;
                                break;
                            case "Connection State Authentication Failed":
                                $document.trigger("app/load/end");
                                $("#databaseManager").find(".error-msg").text(json).show();
                                return;
                                break;
                            case "Connection Ready":
                                break;
                            case "Connection State Control: Authentication success":
                                console.log(json);
                                return;
                            default:
                                console.warn(json);
                                return;
                        }
                        
                        $document.trigger("app/load/end");
                        $("#databaseManager").dialog("close");

                        //Ask confirm
                        var text=_D("All changes will be lost. Continue?");
                        $document.trigger("app/confirm",[text,function(){

                            application.newProject();

                            $document.trigger("app/load/begin",["Download project","bar"]);

                            //Start upload
                            QT.eve.download(
                                QT.applicationPath() +"/data/temp_download.eve",
                                function(json){
                                    //console.warn(json);

                                    //Progress bar
                                    $("#loader").find(".progressbar").progressbar("value", parseInt(json["GetPercentage"],10));

                                    //Check if is end
                                    if(! (json["IsEnd"] === "true") ){
                                        return;
                                    }

                                    $("#databaseManager").find(".progressbar").progressbar("value", 100);

                                    //Disconnect Eve
                                    if(!model["bWasConnect"]){
                                        QT.eve.disconnect();
                                    }

                                    delete model["bWasConnect"];

                                    //Open temporary project
                                    //application.loadProject(QT.applicationPath() +"/data/temp_download.eve");
                                    var oResponse = QT.loadProject(QT.applicationPath() +"/data/temp_download.eve");

                                    //Remove temporary project
                                    QT.deleteFile("../temp_download.eve");

                                    if(oResponse.status.toLowerCase() != "ok"){
                                        $document.trigger("app/error",["Can't load project"]);
                                        return;
                                    }

                                    var oProject = JSON.parse( QT.readFile("../project/project.data") );

                                    application.loadProject(oProject);

                                    //Set connected user
                                    application.connectUser( application.getUserByName($("#databaseManager").find(".user").val()) );

                                    $document.trigger("app/load/end");
                                    //$document.trigger("app/info",["Download complete"]);
                                }
                            );//end callback function

                        }]);
                    }
                );
                break;
            case "load":
                var user = m_$element.find(".user").val();
                var password = hex_md5( m_$element.find(".password").val() );
                    //var password = m_$element.find(".password").val();

                var aUsers = m_oParam.json.Users;
                var find = false;
                var authorized = false;

                for(var i=0; i<aUsers.length; ++i){
                    if(aUsers[i].name == user){
                        find = true;
                        if(aUsers[i].password == password){
                            authorized = true;
                        }
                    }
                }

                //Close dialog
                m_$element.dialog("close");

                //Check
                if(!find){
                    $document.trigger("app/error",["User does not exist"]);
                    //QT.clearProject();
                    return;
                }

                if(!authorized){
                    $document.trigger("app/error",["User not authorized"]);
                    //QT.clearProject();
                    return;
                }

                //New project
                application.newProject();

                //Load whole project
                QT.loadProject(m_oParam.project.projectPath,presenter.preferences.getParameter("projectsDir"));
                var oProject = JSON.parse( QT.readFile("../project/project.data") );

                //TODO sostituire con loadProject();
                application.loadProject(oProject);

                //Set connected user
                var oUsersRoot = eveManager.getUsersRoot();
                var oNode;
                for(var i=0; i<oUsersRoot.children.length;++i){
                    oNode = oUsersRoot.children[i];
                    if(oNode.getData().name == user){
                        break;
                    }
                }

                application.connectUser( oNode );
               // application.connectUser( application.getUserByName(user) );

                //Set current project to preferences
                presenter.preferences.setParameter("currentProject",m_oParam.project);

                //Add current project to recent projects list
                presenter.preferences.addRecentProject(m_oParam.project);

                //Save project MD5
                model["project/md5"] = QT.MD5(m_oParam.project.projectPath);

                //Select connected user
                //console.log(application.getUserByName(user));
                //application.selectUser( application.getUserByName(user) );
                //TODO serve selezionare un utente???
                break;
        }
    };
}