/*
 * jQuery Methods
 *
 * Author: Ilevia
 *
 */
"use strict";

(function($){
	
	//Load html code with synchronous ajax call and with no cache
	$.fn.loadSync = function(iUrl){
		var $this = this;
				
		//Do ajax call
		$.ajax({
			url: iUrl,
			//cache: false,
			cache: true,
			async: false,
			complete: function(jqXHR,status){
				
				if(status == "success"){
					$this.html(jqXHR.responseText);
				}
			}
		});
	
	};
	
	//Load javascript code with synchronous ajax call and with no cache
    $.loadSyncScript = function(iUrl){
        var $this = this;
                
        //Do ajax call
        $.ajax({
            url: iUrl,
            dataType: "script",
            cache: false,
            async: false,
            complete: function(jqXHR,status){
                
            },
            error: function(jqXHR,status){
                console.error(jqXHR);
            }
        });
    
    };
    
    //Load JSON code with synchronous ajax call and with no cache
    $.getSyncJSON = function(iUrl){
                
        //Do ajax call
        var jqXHR  = $.ajax({
          dataType: "json",
          url: iUrl,
          cache: false,
          async: false
        });
        
        return jqXHR.responseJSON;
    
    };

    /*
    //Check if element is hidden by overflow
    // Define the custom selector.
    $.expr[':'].hideByParentOverflow = function(objNode, intStackIndex, arrProperties, arrNodeStack){
        // Create an array to hold the arguments passed to
        // the custom jquery selector. The first several
        // data items are just meta-data about the selector.
        // The list of arguments gets passed as a string -
        // we are eval'ing it into an array.
        var arrArguments = eval(
            "([" + arrProperties[ 3 ] + "])"
        );

        // Create a jQuery version of this node.
        var jThis = $( objNode );

        // Check to see if this node has any of the given
        // titles. If so, return true (we only need to find
        // one of the titles to qualify).
        for (var i = 0 ; i < arrArguments.length ; i++){

        // Check for title equality.
            if (jThis.attr( "title" ) == arrArguments[ i ]){

        // We found a title match, return true to
        // indicate that this node should be included
        // in the returned jQuery stack.
                return( true );

            }

        }

        // If we have made it this far, then we found no
        // match. Return false to indicate that this node
        // did not match our selector.
        return( false );
    };
    */
	
})(jQuery);


/* jQuery Tiny Pub/Sub - v0.7 - 10/27/2011
 * http://benalman.com/
 * Copyright (c) 2011 "Cowboy" Ben Alman; Licensed MIT, GPL */
(function($){

  var o = $({});

  $.subscribe = function(){ o.on.apply(o,arguments); };

  $.unsubscribe = function(){ o.off.apply(o,arguments); };

  $.publish = function(){ o.trigger.apply(o,arguments); };

}(jQuery));


/* Example 

function handle(e, a, b, c) {
  // `e` is the event object, you probably don't care about it.
  console.log(e);
  console.log(a);
  console.log(b);
  console.log(c);
};

$.subscribe("/some/topic", handle);

$.publish("/some/topic", ["sono","in","tre"]);

$.publish("/some/topic", ["a","b","c"]);

$.unsubscribe("/some/topic", handle); // Unsubscribe just this handler

$.publish("/some/topic", ["a","b","c"]);

*/